SystemOrganization addCategory: #ConfigurationOfPharoLauncher!

Object subclass: #ConfigurationOfPharoLauncher
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharoLauncher'!

!ConfigurationOfPharoLauncher commentStamp: '<historical>' prior: 0!
A ConfigurationOfPharoLauncher is !

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'ErwanDouaille 4/27/2013 21:05'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPharoLauncher class methodsFor: 'metacello tool support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'DamienCassou 4/29/2013 10:34'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^ self loadBleedingEdge! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'ErwanDouaille 4/27/2013 21:05'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'ErwanDouaille 4/27/2013 21:05'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'accessing' stamp: 'ErwanDouaille 4/27/2013 21:05'!
project

	^self new project! !

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'ErwanDouaille 4/27/2013 21:05'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ChristopheDemarey 12/20/2013 16:48'!
baseline01: spec
	<version: '0.1-baseline'>
	spec
		for: #common
		do: [ 
			spec blessing: #baseline.
			spec repository: 'http://smalltalkhub.com/mc/Pharo/PharoLauncher/main/'.
			spec package: 'PharoLauncher-Core' with: [ spec requires: #('XML parsing' 'OSProcess' 'JSON' 'STON') ].
			spec package: 'PharoLauncher-Spec' with: [ spec requires: #('PharoLauncher-Core') ].
			spec package: 'PharoLauncher-Tests-Core' with: [ spec requires: 'PharoLauncher-Core' ].
			self externalDependencies: spec ]! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:31'!
bleedingEdge: spec
	<symbolicVersion: #bleedingEdge>
	spec for: #common version: '0.1-baseline'! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
development: spec
	<symbolicVersion: #development>
	spec for: #common version: #notDefined! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ChristopheDemarey 12/20/2013 11:17'!
externalDependencies: spec
	spec
		project: 'XML parsing'
		with: [ 
			spec
				className: 'ConfigurationOfXMLParser';
				loads: #('Core');
				repository: 'http://www.smalltalkhub.com/mc/PharoExtras/XMLParser/main' ].
	spec
		project: 'OSProcess'
		with: [ 
			spec
				className: 'ConfigurationOfOSProcess';
				loads: #('Core');
				repository: 'http://www.squeaksource.com/MetacelloRepository' ].
	
		spec
		project: 'Zinc'
		with: [ 
			spec
				className: 'ConfigurationOfZincHTTPComponents';
				loads: #('Zinc-HTTP');
				repository: 'http://www.squeaksource.com/ZincHTTPComponents' ].
	
	"Please change the #package:with: to a call to #project:with: as soon as there is a ConfigurationOfJSON"
	spec
		package: 'JSON'
		with: [ 
			spec
				repository: 'http://www.smalltalkhub.com/mc/NicolasPetton/JSON/main';
				file: 'JSON-ul.35' ].
			
	spec
		project: 'STON'
		with: [ 
			spec
				className: 'ConfigurationOfSton';
				versionString: #stable;
				repository: 'http://ss3.gemstone.com/ss/STON' ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'ErwanDouaille 4/27/2013 21:05'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 4/29/2013 10:32'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #common version: #notDefined! !
